// demoplugin.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "../../TlenSources/plugin/plugin_struct.h"
#include "../../TlenSources/plugin/plugin_skin.h"
#include "../../TlenSources/plugin/plugin_contactlist_defs.h"
#include "AggressiveOptimize.h"
#include <process.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "resource.h"

HINSTANCE hInst;
TLENPLUGINFUNCTIONS *tlen_functions;

int SectionHandle1 = 0, GroupHandle1 = 0, ElementHandle1 = 0, ElementHandle2 = 0;
HANDLE hThread = NULL; 
HANDLE hThread2 = NULL; 
bool bexit = false;
HWND window = NULL;
HANDLE hook;

TLENPLUGININFO pluginInfo={
	sizeof(TLENPLUGININFO),
	"ContactListPlugin",
    PLUGIN_API_VERSION,
	MAKE_DWORD_VERSION(1,0,0,0),
	"Plugin demonstrujcy funkcje listy kontaktw",
	" Prawa autorskie",
	"MediaOne sp. z o.o.",
	"info@mediaone.pl",
	"http://www.mediaone.pl",
	0,
	0,
	0,		
	0		
};

extern "C" __declspec(dllexport) TLENPLUGININFO* GetPluginInfo(DWORD TlenVersion);
extern "C" __declspec(dllexport) int LoadPlugin(TLENPLUGINFUNCTIONS *tlen_functions);
extern "C" __declspec(dllexport) int UnloadPlugin(void);

static int EnumerationCallback(WPARAM wParam, LPARAM lParam)
{
 ContactListItemDef *item = (ContactListItemDef *) wParam;
 HWND lBox = (HWND) lParam;

 static char temp[1024];
 temp[0] = '\0';

 if (item)
 {
	 if (item->ItemKind == CONTACTLIST_ITEMKIND_SECTION) strcat(temp, "S: ");
	 else if (item->ItemKind == CONTACTLIST_ITEMKIND_GROUP) strcat(temp, "     G: ");
	 else if (item->ItemKind == CONTACTLIST_ITEMKIND_ELEMENT) strcat(temp, "          E: ");

	 if (item->ItemKind == CONTACTLIST_ITEMKIND_ELEMENT) 
	 { 
	  sprintf(temp + strlen(temp), "(%d) %s    [%s %s %s %s]", item->ItemHandle, item->MainText, item->ContactInfo.ProtocolID, item->ContactInfo.ContactID, item->ContactInfo.FullID, item->ContactInfo.User);
	 }
	 else
	 {
	  sprintf(temp + strlen(temp), "(%d) %s", item->ItemHandle, item->MainText);
	 }

	 SendMessage(lBox, LB_ADDSTRING, 0, (LPARAM) temp);
 }

 return 0;
}

static int IconsEnumerationCallback(WPARAM wParam, LPARAM lParam)
{
 ContactListIconDef *icon = (ContactListIconDef *) wParam;
 HWND lBox = (HWND) lParam;

 static char temp[1024];

 if (icon)
 {
	 sprintf(temp, "ID: %s   StatesCount: %d   CurrentState: %d", icon->ID, icon->StatesCount, icon->CurrentState);
	 SendMessage(lBox, LB_ADDSTRING, 0, (LPARAM) temp);
 }

 return 0;
}
LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wparam, LPARAM lParam)
{
	switch (message) 
	{
		case WM_INITDIALOG:
		{	
			SetDlgItemText(hWnd, IDC_EDIT1, "New Main Text...");
			ShowWindow(hWnd, SW_SHOW);
			UpdateWindow(hWnd);
			return TRUE;
		}
		case WM_DESTROY:
		{
			window = NULL;
			break;
		}
		case WM_CLOSE:
		{
			DestroyWindow(hWnd);
			break;
		}
		case WM_COMMAND:
		{
		 static int value;
		 switch (LOWORD(wparam))
		 {
			case IDC_GRUPY:
			{
				tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_GETPROPERTY, (WPARAM) TLEN_CONTACTLIST_PROPERTY_GROUPVISIBLE, (LPARAM) &value);
				value = !value;
				tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_SETPROPERTY, (WPARAM) TLEN_CONTACTLIST_PROPERTY_GROUPVISIBLE, (LPARAM) &value);
				break;
			}
			case IDC_OFFLINE:
			{
				tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_GETPROPERTY, (WPARAM) TLEN_CONTACTLIST_PROPERTY_OFFLINEVISIBLE, (LPARAM) &value);
				value = !value;
				tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_SETPROPERTY, (WPARAM) TLEN_CONTACTLIST_PROPERTY_OFFLINEVISIBLE, (LPARAM) &value);
				break;
			}
			case IDC_PASKISTANU:
			{
				tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_GETPROPERTY, (WPARAM) TLEN_CONTACTLIST_PROPERTY_STATUSBARVISIBLE, (LPARAM) &value);
				value = !value;
				tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_SETPROPERTY, (WPARAM) TLEN_CONTACTLIST_PROPERTY_STATUSBARVISIBLE, (LPARAM) &value);
				break;
			}
			case IDC_STANYOPISOWE:
			{
				tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_GETPROPERTY, (WPARAM) TLEN_CONTACTLIST_PROPERTY_STATUSTEXTVISIBLE, (LPARAM) &value);
				value = !value;
				tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_SETPROPERTY, (WPARAM) TLEN_CONTACTLIST_PROPERTY_STATUSTEXTVISIBLE, (LPARAM) &value);
				break;
			}
			case IDC_ENUMERATEALL:
			case IDC_ENUMERATEVISIBLE:
			case IDC_ENUMERATECHILDREN:
			{
				SendMessage(GetDlgItem(hWnd, IDC_ENUMERATED), LB_RESETCONTENT, 0, 0);

				ContactListItemsEnumerationDef def;
				InitializeStruct(def);

				if (LOWORD(wparam) == IDC_ENUMERATEALL)
					def.EnumerationKind = CONTACTLIST_ENUMERATIONKIND_ALL;
				else if (LOWORD(wparam) == IDC_ENUMERATEVISIBLE)
					def.EnumerationKind = CONTACTLIST_ENUMERATIONKIND_VISIBLE;
				else if (LOWORD(wparam) == IDC_ENUMERATECHILDREN)
					def.EnumerationKind = CONTACTLIST_ENUMERATIONKIND_CHILDREN;

				def.CallbackFunc = EnumerationCallback;
				def.OwnerValue = (void *) GetDlgItem(hWnd, IDC_ENUMERATED);
				def.ParentHandle = GetDlgItemInt(hWnd, IDC_PARENTHANDLE, NULL, FALSE);


				tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_ENUMERATEITEMS, (WPARAM) &def, NULL);
				break;
			}
			case IDC_CHANGEITEM:
			{
				//Dodajemy sekcj 'Sekcja testowa'
				ContactListItemDef item;
				InitializeStruct(item);
				item.ChangeFlags = CONTACTLIST_ITEMCHANGEFLAG_MAINTEXT | CONTACTLIST_ITEMCHANGEFLAG_REDRAWITEM;
				char buf[128];
				buf[127] = '\0';
				GetDlgItemText(hWnd, IDC_EDIT1, buf, 127);
				item.MainText = buf;
				tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_CHANGEITEM, (WPARAM) ElementHandle1, (LPARAM) &item);
				break;
			}
			case IDC_ENUMERATEICONS:
			{
				SendMessage(GetDlgItem(hWnd, IDC_ENUMERATED), LB_RESETCONTENT, 0, 0);

				ContactListItemsEnumerationDef def;
				InitializeStruct(def);

				def.CallbackFunc = IconsEnumerationCallback;
				def.OwnerValue = (void *) GetDlgItem(hWnd, IDC_ENUMERATED);
				def.ParentHandle = ElementHandle1;

				tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_ENUMERATEITEMICONS, (WPARAM) &def, NULL);
				break;
			}
			case IDC_ADDITEMICONS:
			{
				AddItemIconsDef def;
				InitializeStruct(def);

				   ContactListIconDef icon[2];
				   InitializeStruct(icon[0]);
				   InitializeStruct(icon[1]);
   
				   TlenSingleImageDef sicons[2];
				   InitializeStruct(sicons[0]);
				   InitializeStruct(sicons[1]);
				   sicons[0].SkinID = icIDTlenAway;
				   sicons[1].SkinID = icIDTlenChat;

				   icon[0].ID = "IconID_1";
				   icon[0].StatesCount = 1;
				   icon[0].IconKind = CONTACTLIST_ICONKIND_PRETEXT;
				   icon[0].CurrentState = 1; //( +1!!!)
				   icon[0].SingleIcons = sicons;

				   icon[1].ID = "IconID_2";
				   icon[1].StatesCount = 1;
				   icon[1].IconKind = CONTACTLIST_ICONKIND_POSTTEXT;
				   icon[1].CurrentState = 1; //( +1!!!)
				   icon[1].SingleIcons = sicons + 1;

				def.Icons = icon;
				def.IconsCount = 2;
				def.ItemHandle = ElementHandle1;

				tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_ADDITEMICONS, (WPARAM) &def, NULL);
				break;
			}
			case IDC_REMOVEITEMICONS:
			{
				tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_REMOVEITEMICON, (WPARAM) ElementHandle1, (LPARAM) "IconID_1");
				tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_REMOVEITEMICON, (WPARAM) ElementHandle1, (LPARAM) "IconID_2");
				break;
			}
		 }

		 break;
		}
	}

	return 0;
}


BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	hInst=hinstDLL;
	return TRUE;
}

__declspec(dllexport) TLENPLUGININFO* GetPluginInfo(DWORD tlenVersion)
{
	return &pluginInfo;
}

DWORD WINAPI ThreadFunc( LPVOID lpParam ) 
{ 
 static ContactListIconDef ic;
 static int state = 1;
 InitializeStruct(ic);
  
 while (!bexit && state <= 7)
 {
  state++;

  ic.ID = "MojaIkonka";
  ic.Flags |= CONTACTLIST_ICONFLAG_CHANGE_CURRENTSTATE;
  ic.CurrentState = state;

  tlen_functions->CallTlenFunctionTS(hInst, TLEN_CONTACTLIST_CHANGEITEMICON, (WPARAM) ElementHandle1, (LPARAM) &ic);
  if (state > 7) state = 1;
  Sleep(250);
 }

 state = 0;

 return 0; 
} 

DWORD WINAPI RedrawThreadFunc( LPVOID lpParam ) 
{ 
 while (!bexit)
 {
  Sleep(100);
  if (bexit) break;
  tlen_functions->CallTlenFunctionTS(hInst, TLEN_CONTACTLIST_REDRAWITEM, (WPARAM) ElementHandle2, NULL);
 }

 return 0; 
} 


static int ItemIconCallBack(WPARAM wParam,LPARAM lParam)
{
 ItemCallBackMouseDef *mdef = (ItemCallBackMouseDef *) lParam;
 ItemCallBackEventDef *def = (ItemCallBackEventDef *) wParam;

 if (def->Event == CONTACTLIST_ITEMCALLBACK_MOUSEENTER && !hThread)
 {
    DWORD dwThreadId; 
    hThread = CreateThread(NULL, 0, ThreadFunc, NULL, 0, &dwThreadId);
 }

 return 0;
}

static int ItemCallBack(WPARAM wParam,LPARAM lParam)
{
 ItemCallBackEventDef *def = (ItemCallBackEventDef *) wParam;
 static int red = 0;

 if (def->Event == CONTACTLIST_ITEMCALLBACK_GETHEIGHT)
 {
  return 8;
 }
 else if (def->Event == CONTACTLIST_ITEMCALLBACK_DRAWITEM)
 {
  ItemCallBackOwnerDrawnDef *o_draw = (ItemCallBackOwnerDrawnDef *) lParam;

  static int cstart = 0;
  static int tmp;
  tmp = cstart;

  for(int i=o_draw->itemRect->left; i < o_draw->itemRect->right; i++)
  {
   COLORREF crBackground;
   if (def->Item->Flags1 & CONTACTLIST_ITEMFLAG1_SELECTED)
	   crBackground = RGB(0,0,abs((tmp % 511) - 255));
   else 
	   crBackground = RGB(0,abs((tmp % 511) - 255), 0);
   tmp++;
   HPEN hBluePen = CreatePen(PS_SOLID, 1, crBackground);
   HPEN hOldPen = (HPEN)SelectObject(o_draw->itemHdc, (HGDIOBJ)hBluePen);
   MoveToEx(o_draw->itemHdc, i ,o_draw->itemRect->top, NULL);
   LineTo(o_draw->itemHdc, i, o_draw->itemRect->bottom);
   SelectObject(o_draw->itemHdc, hOldPen);
   DeleteObject(hBluePen);
  }

  cstart+=20;
 }

 return 0;
}


static int NotificationHook(WPARAM wParam,LPARAM lParam)
{
	//tutaj obsugujemy sobie powiadomienia
	static char buf[128];
	sprintf(buf, "Event code: %d", wParam);

	HWND lbox = GetDlgItem(window, IDC_LOG);
	SendMessage(lbox, LB_ADDSTRING, 0, (LPARAM) buf);
	SendMessage(lbox, LB_SETCARETINDEX, SendMessage(lbox, LB_GETCOUNT, 0, 0), MAKELPARAM(FALSE, 0));

	return 0;
}
 
__declspec(dllexport) int LoadPlugin(TLENPLUGINFUNCTIONS *functions)
{
	tlen_functions = functions;

  window = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG1), NULL, (DLGPROC) WindowProc);

  hook = tlen_functions->HookTlenEvent(hInst, TLEN_CONTACTLIST_NOTIFICATION, NotificationHook);

  //Dodajemy sekcj 'Sekcja testowa'
  ContactListItemDef item;
  InitializeStruct(item);
  item.ItemKind = CONTACTLIST_ITEMKIND_SECTION;
  item.Flags1 =  CONTACTLIST_ITEMFLAG1_EXPANDED | CONTACTLIST_ITEMFLAG1_EXPANDABLE |
                CONTACTLIST_ITEMFLAG1_CHILDRENVISIBLE;
  item.MainText = "Sekcja testowa";
  item.PreviousItemHandle = CONTACTLIST_ITEMPOS_FIRST;

  if (tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_ADDITEM, (WPARAM) &item, NULL) == 0)
  {
   SectionHandle1 = item.ItemHandle;
  }

  //Dodajemy grup "Przykadowa grupa"
  InitializeStruct(item);
  item.ItemKind = CONTACTLIST_ITEMKIND_GROUP;
  item.Flags1 = CONTACTLIST_ITEMFLAG1_EXPANDED |
                CONTACTLIST_ITEMFLAG1_EXPANDABLE;

  item.MainText = "Przykadowa grupa";
  item.SectionHandle = SectionHandle1;

  if (tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_ADDITEM, (WPARAM) &item, NULL) == 0)
  {
   GroupHandle1 = item.ItemHandle;
  }

  //Dodajemy pierwszy element 
  InitializeStruct(item);

   item.SectionHandle = SectionHandle1;
   item.GroupHandle = GroupHandle1;

   item.ItemKind = CONTACTLIST_ITEMKIND_ELEMENT;
   item.ItemSubKind = CONTACTLIST_ITEMSUBKIND_CONTACT;

   item.MainText = "Element grupy";
   item.ItemHint = "Tekst w dymku...";

   ContactListIconDef icon;
   TlenSingleImageDef sicons[7];
   for (int i = 0; i < 7; i++)
   {
	   InitializeStruct(sicons[i]);
   }

   sicons[0].SkinID = icIDTlenOnline;
   sicons[1].SkinID = icIDTlenChat;
   sicons[2].SkinID = icIDTlenAway;
   sicons[3].SkinID = icIDTlenXA;
   sicons[4].SkinID = icIDTlenDND;
   sicons[5].SkinID = icIDTlenInvisible;
   sicons[6].SkinID = icIDTlenOffline;

   InitializeStruct(icon);

   icon.ID = "MojaIkonka";
   icon.StatesCount = 7;
   icon.IconKind = CONTACTLIST_ICONKIND_PRETEXT;
   icon.CurrentState = 1; //( +1!!!)
   icon.SingleIcons = sicons;
   icon.CallBackFunc = ItemIconCallBack;

   item.Icons = &icon;
   item.IconsCount = 1;
   //item.CallBackFunc = ContactListItemNotificationHandler;
  
   if (tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_ADDITEM, (WPARAM) &item, NULL) == 0)
   {
	ElementHandle1 = item.ItemHandle;
   }

  //Dodajemy drugi element - owner drawn 
  InitializeStruct(item);

   item.SectionHandle = SectionHandle1;
   item.GroupHandle = GroupHandle1;

   item.ItemKind = CONTACTLIST_ITEMKIND_ELEMENT;
   item.ItemSubKind = CONTACTLIST_ITEMSUBKIND_OTHER;

   item.Flags1 |= CONTACTLIST_ITEMFLAG1_OWNERDRAWN | CONTACTLIST_ITEMFLAG1_OWNERHEIGHT; 

   item.CallBackFunc = ItemCallBack;
  
   if (tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_ADDITEM, (WPARAM) &item, NULL) == 0)
   {
	ElementHandle2 = item.ItemHandle;
    DWORD dwThreadId; 
    hThread2 = CreateThread(NULL, 0, RedrawThreadFunc, NULL, 0, &dwThreadId);
   }

  return 0;
}

__declspec(dllexport) int UnloadPlugin(void)
{
	bexit = true;
	//Czekamy na zakoczenie wtku z animacj
	if (hThread) WaitForSingleObject(hThread, INFINITE);
	if (hThread2) WaitForSingleObject(hThread2, INFINITE);

	if (window) DestroyWindow(window);
	
	tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_REMOVEITEM, (WPARAM) ElementHandle1, NULL);
	tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_REMOVEITEM, (WPARAM) ElementHandle2, NULL);
    tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_REMOVEITEM, (WPARAM) GroupHandle1, NULL);
    tlen_functions->CallTlenFunction(hInst, TLEN_CONTACTLIST_REMOVEITEM, (WPARAM) SectionHandle1, NULL);

	tlen_functions->UnhookTlenEvent(hInst, hook);
	return 0;
}
